<?php
namespace Modules\EST\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class LancEstoque extends \Zeedhi\Framework\Controller\Simple {

    protected $erpController;
    
    public function __construct(Modules\EST\Services\LancEstoqueService $LancEstoqueService) {
        $this->LancEstoqueService = $LancEstoqueService;
    }
	
	/********************INICIO METODOS SERVER**************/
    
    public function lancamentoEstoque(Request $request, Response $response) {
		try {   
			
			if(empty($_POST)){
				$input = file_get_contents('php://input');
				$requestData = json_decode($input, true); 
			}else{
				$requestData = $_POST;
			}
			$dataSet = $requestData;

			$arrJson = $dataSet;
			$json = json_encode($arrJson);
			//$this->LancEstoqueService->gravaLogImportaNFEDEBUG('Entrada', $json);
            $importaEntrada = $this->LancEstoqueService->lancamentoEstoque($dataSet);
            if(!isset($importaEntrada['P_MENSAGEMERRO'])){
            	$bkpError = $importaEntrada;
            	$importaEntrada = array();
            	$importaEntrada['P_MENSAGEMERRO'] = $bkpError;
            }
            	
			if($importaEntrada['P_MENSAGEMERRO'] == 'S'){
				$dataSet = array(
		    					'Status'=> 'S',
		    					'Mensagem'=> 'Importado com sucesso'
			    			);
			}else{
				$dataSet = array(
		    					'Status'=> 'E',
		    					'Mensagem'=> $importaEntrada['P_MENSAGEMERRO']
			    			);
			}
		
			$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('response', $dataSet));
				
        }catch(\Exception $e){
			$mensagem = $e->getMessage();
			$this->LancEstoqueService->gravaLogWebservice($json, 'importaMoviest', $arrJson, $mensagem);
			$return = array(
            					'Status'=> 'E',
            					'Mensagem'=> $e->getMessage()
            			);
			$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('response', $return));
            //$response->setError(new Response\Error($e->getMessage(), $e->getCode()));
			//$this->buildXml($response, 'CadastraProdutoResponse');
		}
    }
    
	private function validaCamposObrigatorios($paramArray, $requiredFields){
		$missingFields = '';
		
		$paramArrayKeys = array();
		foreach($paramArray as $key => $value){
			array_push($paramArrayKeys, $key);
		}
		
		$missingFieldsArray = array_filter($requiredFields, function($key) use ($paramArrayKeys){
			return !in_array($key, $paramArrayKeys);
		});
		foreach($missingFieldsArray as $field){
			$missingFields = empty($missingFields)?''.$field : $missingFields.', '.$field;
		}
		
		return $missingFields;
	}
	
	private function obj_to_array($data){
	    if (is_array($data) || is_object($data)){
	        $result = array();
	        foreach ($data as $key => $value){
	            $result[$key] = $this->obj_to_array($value);
	        }
	        return $result;
	    }
	    return $data;
	}

	private function buildXml($data, $method){
		// coloca no formato XML
		$xml = $this->arrayToXml($data, $method);
		return $xml;
	}
	
	private function arrayToXml($data, $elementName) {
		$result = '';
	    foreach($data as $key => $value) {
	        if (is_array($value)) {
	        	if(is_numeric($key) || $key == 'NFUnica' || $key == 'SEPUnica'){
	        		$result .= $this->arrayToXml($value,'ITEM'.$elementName);
	        	}else{
	        		$result .= $this->arrayToXml($value, $key);
	        	}
	        } else {
	        	$result .= '<'.$key.'>'.  $value . '</'.$key.'>';
	        }
	    }
	    if ($elementName) {
	     	return '<'.$elementName.'>'.  $result. '</'.$elementName.'>';
	    } else {
	    	return $result;
	    }
	}
	
	public function array_some(array $array, callable $fn) {
        foreach ($array as $value) {
            if($fn($value)) {
                return true;
            }
        }
        return false;
    }
    
}