<?php
namespace Planejamento\Repositories;

class Pratfili extends \Doctrine\ORM\EntityRepository
{
    public static function deletaReceita ($cdprato, $cdfilauxprat, $cdfilial, $nrorg) {

        $query = "DELETE FROM PRATFILI
                  WHERE
                    CDFILAUXPRAT = :CDFILAUXPRAT AND
                    CDPRATO  = :CDPRATO          AND
                    CDFILIAL  = :CDFILIAL        AND
                    NRORG        = :NRORG";

        $param = array(
            "CDPRATO"      => $cdprato,
            "CDFILAUXPRAT" => $cdfilauxprat,
            "CDFILIAL"     => $cdfilial,
            "NRORG"        => $nrorg
        );

        try {
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($query, $param);
            return true;
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function adicionaReceitaPratoFilial($cdprato, $cdfilauxprat, $nrorg, $cdfilialorig,$cdservorig,
                                                      $qtpadrao, $cdfilidest,  $receitaorig ) {

        $query = "SELECT
                    B.CDFILAUXDEST,
                    B.CDPRATODEST,
                    B.CDFILIDEST,
                    A.NRCORPRI,
                    A.NRCORSEQ,
                    A.NRCORAUX,
                    B.QTPADRAO,
                    A.QTCONTAI,
                    A.HRVALCON,
                    A.NMFANTASIA,
                    A.QTCARBO,
                    A.QTLIPID,
                    A.QTPROTE,
                    A.QTCALOR,
                    A.QTALCOO
                  FROM(
                    SELECT

                      NRCORPRIPRAT AS NRCORPRI,
                      NRCORSEQPRAT AS NRCORSEQ,
                      NRCORAUXPRAT AS NRCORAUX,
                      QTCONTAIPRAT AS QTCONTAI,
                      HRVALCONPRAT AS HRVALCON,
                      NMFANTASIAPR AS NMFANTASIA,
                      QTCARBOPRPAD AS QTCARBO,
                      QTLIPIDPRPAD AS QTLIPID,
                      QTPROTEPRPAD AS QTPROTE,
                      QTCALORPRPAD AS QTCALOR,
                      QTALCOOPRPAD AS QTALCOO,
                      'P' AS IDTIPORECE
                    FROM
                      PRATPADR
                    WHERE
                      (CDPRATO       = '{$cdprato}')   AND
                      (CDFILAUXPRAT  = '{$cdfilauxprat}')

                    UNION ALL

                    SELECT

                      NRCORPRIFILI AS NRCORPRI,
                      NRCORSEQFILI AS NRCORSEQ,
                      NRCORAUXFILI AS NRCORAUX,
                      QTCONTAIFILI AS QTCONTAI,
                      HRVALCONFILI AS HRVALCON,
                      NMFANTASIAPF AS NMFANTASIA,
                      QTCARBOPRFIL AS QTCARBO,
                      QTLIPIDPRFIL AS QTLIPID,
                      QTPROTEPRFIL AS QTPROTE,
                      QTCALORPRFIL AS QTCALOR,
                      QTALCOOPRFIL AS QTALCOO,
                      'F' AS IDTIPORECE
                    FROM
                      PRATFILI
                    WHERE
                      (CDPRATO       = '{$cdprato}')      AND
                      (CDFILAUXPRAT  = '{$cdfilauxprat}') AND
                      (CDFILIAL      = '{$cdfilialorig}')

                    UNION ALL

                    SELECT

                      NRCORPRISERV AS NRCORPRI,
                      NRCORSEQSERV AS NRCORSEQ,
                      NRCORAUXSERV AS NRCORAUX,
                      QTCONTAISERV AS QTCONTAI,
                      HRVALCONSERV AS HRVALCON,
                      NMFANTASIASE AS NMFANTASIA,
                      QTCARBOPRSER AS QTCARBO,
                      QTLIPIDPRSER AS QTLIPID,
                      QTPROTEPRSER AS QTPROTE,
                      QTCALORPRSER AS QTCALOR,
                      QTALCOOPRSER AS QTALCOO,
                      'S' AS IDTIPORECE
                    FROM
                      PRATSERV
                    WHERE
                      (CDPRATO       = '{$cdprato}')      AND
                      (CDFILAUXPRAT  = '{$cdfilauxprat}') AND
                      (CDFILIAL      = '{$cdfilialorig}') AND
                      (NRORG         = '{$nrorg}')        AND
                      (CDSERVFILI    = '{$cdservorig}')
                  ) A RIGHT JOIN
                  (SELECT
                      '{$cdfilauxprat}' AS CDFILAUXDEST,
                      '{$cdprato}'      AS CDPRATODEST,
                      '{$cdfilidest}'   AS CDFILIDEST,
                      '{$qtpadrao}'     AS QTPADRAO,
                      '{$receitaorig}'  AS IDTIPORECE
                  FROM DUAL) B
                  ON A.IDTIPORECE = B.IDTIPORECE";


        try {
            $conn = \Setforms2\Runtime\Connection::getInstance();
            return $conn->fetchAll($query);
        } catch (\Exception $e) {
            throw $e;
        }

    }

}