<?php
namespace Planejamento\Util;

use \Planejamento\Entities\Paramplaneja;
use \Geral\Entities\Grupoper;
use \Geral\Entities\Paramgeral;
use \Geral\Entities\Opergrupop;
use \Geral\Util\Ambiente;

/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 14/01/13
 * Time: 16:43
 */
class Parametros
{
    /** @var Paramplaneja */
    protected $paramPlaneja;
    protected $paramGeral;
    protected $permissoes;


    /** @var Parametros */
    private static $instancia = null;

    protected function __construct($filial = null) {
        if (empty($filial) === true) {
            $filial = Ambiente::getCdFilial();
        }

        $params = array(Ambiente::getNrorg(), $filial);
        $this->paramPlaneja = Paramplaneja::getObjectByWhere("NRORG = ? AND CDFILIAL = ?", $params);
        $this->paramGeral = Paramgeral::getObjectByWhere("NRORG = ?", array(Ambiente::getNrorg()));
        
        $this->permissoes = array();
    }

    public static function  getInstancia($filial = null) {
        if(self::$instancia === null) {
            self::$instancia = new self($filial);
        }

        return self::$instancia;
    }
    
    
// PARAMENTROS DO PLANEJAMENTO
    

    public static function getBloqueiaCardapioDiaNaoUtil() {
        $bloqueia = self::getInstancia()->paramPlaneja->getIdcardiautil();
        return $bloqueia == 'S' ? true : false;
    }

    public static function getVerificaEfetivos() {
        return self::getInstancia()->paramPlaneja->getIdefetcardia();
    }

    public static function getTipoCustoPlanejado() {
        $tipoCusto = self::getInstancia()->paramPlaneja->getCdtipocustopla();
        return empty($tipoCusto) ? '01' : $tipoCusto;
    }

    public static function getTipoCustoRealizado() {
        $tipoCusto = self::getInstancia()->paramPlaneja->getCdtipocustorea();
        return empty($tipoCusto) ? '01' : $tipoCusto;
    }

    public static function getExibeCusto() {
        $exibCusto = self::getInstancia()->paramPlaneja->getIdexibecusto();
        return empty($exibCusto) === true ? 'R' : $exibCusto;
    }

    public static function getVerificaCustoPadrao() {
        return self::getInstancia()->paramPlaneja->getIdcuspadcar();
    }

    public static function getMontagemCard() {
        $identif = self::getInstancia()->paramPlaneja->getIdperccome();
        return empty($identif) === true ? 'P' : $identif;
    }

    public static function getAcompCusto() {
		$param = self::getInstancia()->paramPlaneja;
		if ($param instanceof Paramplaneja)
			$acompanha = $param->getIdacompcusto();
		else 
			$acompanha = 'N';
			
        return empty($acompanha) === true ? 'N' : $acompanha;
    }

    public static function getBloqFechCardapio() {
        $bloqFech = self::getInstancia()->paramPlaneja->getIdblqfechcard();
        return empty($bloqFech) === true ? 'N' : $bloqFech;
    }

 	public static function getCorDiaNaoUtil() {
        $cor = self::getInstancia()->paramPlaneja->getNrcornutil();
        $corHex = dechex($cor);
        $count = strlen($corHex);
        if(strlen($corHex) == 2) {
        	$corHex = str_pad($corHex, 6 , 0);
        }
        return '#'.$corHex;
    }

    public static function getCorBloqAlt() {
        $cor = self::getInstancia()->paramPlaneja->getNrcornalte();
        $corHex = dechex($cor);
        $count = strlen($corHex);
        if(strlen($corHex) == 2) {
        	$corHex = str_pad($corHex, 6 , 0);
        }
        return '#'.$corHex;
    }

    public static function getCorCardEspecifico() {
        $cor = self::getInstancia()->paramPlaneja->getNrcorcardesp();
        $corHex = dechex($cor);
        return '#'.$corHex;
    }

    public function getConsultaGrupoPrato() {
        return self::getInstancia()-> paramPlaneja->getIdconsgrprat();
    }
    
    public function getIdsomacomest(){
        return self::getInstancia()->paramPlaneja->getIdsomacomest();
    }
    
    public static function getIdganhococc(){
    	$param = self::getInstancia()->paramPlaneja;
    	 
    	if ($param instanceof Paramplaneja)
    		$ganhoCocc = $param->getIdganhococc();
    	else
    		$ganhoCocc = 'S';
    	 
    	return $ganhoCocc;
    }
    public function getIdtempprep(){
    	$param = self::getInstancia()->paramPlaneja;
    	 
    	if ($param instanceof Paramplaneja)
    		$tempPrep = $param->getIdtempprep();
    	else
    		$tempPrep = 'S';
    	 
    	return $tempPrep;
    }
    public static function getIdperdalimp(){
    	$param = self::getInstancia()->paramPlaneja;
    	
    	if ($param instanceof Paramplaneja)
    		$perdaLimp = $param->getIdperdalimp();
    	else
    		$perdaLimp = 'S';
    	
    	return $perdaLimp;
    }
    public static function getIdaprovcocc(){
    	$param = self::getInstancia()->paramPlaneja;
    	 
    	if ($param instanceof Paramplaneja)
    		$aprovCocc = $param->getIdaprovcocc();
    	else
    		$aprovCocc = 'S';
    	 
    	return $aprovCocc;
    }
    public static function getIdaprovlimp(){
    	$param = self::getInstancia()->paramPlaneja;
    	
    	if ($param instanceof Paramplaneja)
    		$aprovLimp = $param->getIdaprovlimp();
    	else
    		$aprovLimp = 'S';
    	
        return $aprovLimp;
    }
    
    public static function getIdLiqBrut(){
    	$param = self::getInstancia()->paramPlaneja;
    	 
    	if ($param instanceof Paramplaneja)
    		$qtLiquBrut = $param->getIdqtliqubrut();
    	else
    		$qtLiquBrut = 'L';
    	 
    	return $qtLiquBrut;
    }
    
    public static function getIdPesqPratNome() {
    	return self::getInstancia()->paramGeral->getIdpesqpratnome();
    }

    public static function getIdApreRece(){
        return self::getInstancia()->paramPlaneja->getIdaprerece();
    }

    public static function getIdBloPratLoc(){
        return self::getInstancia()->paramGeral->getIdblopratloc();
    }

    public static function getIdBloqPraDup(){
        return self::getInstancia()->paramGeral->getIdbloqpradup();
    }

    public static function getCustoPadraoCardapio(){
        return self::getInstancia()->paramPlaneja->getIdcuspadcar();
    }

    public static function getNrCorSafra() {
        $cor = self::getInstancia()->paramPlaneja->getNrcorsafra();
        $corHex = dechex($cor);
        $corHex = str_pad($corHex, 6 , 0, STR_PAD_LEFT);
        return '#'.$corHex;
    }

    public static function getNrCorInicSaf() {
        $cor = self::getInstancia()->paramPlaneja->getNrcorinicsaf();
        $corHex = dechex($cor);
        $corHex = str_pad($corHex, 6 , 0, STR_PAD_LEFT);
        return '#'.$corHex;
    }

    public static function getNrCorEntrsaf() {
        $cor = self::getInstancia()->paramPlaneja->getNrcorentrsaf();
        $corHex = dechex($cor);
        $corHex = str_pad($corHex, 6 , 0, STR_PAD_LEFT);
        return '#'.$corHex;
    }
	
	public static function getIdBlPrCusZer()
	{
	return self::getInstancia()->paramPlaneja->getIdblprcuszer(); 
	}	

    // PERMISSOES DE GRUPO DE OPERADORES

    private function verificaGrupoOper(){
    	/** @var $assocGrupOper Opergrupop[] */
    	$assocGrupOper = Opergrupop::getObjectsByWhere(
    			'NRORG = ? AND CDOPERADOR = ?',
    			array(Ambiente::getNrorg(), Ambiente::getCdoperador())
    	);
    	 
    	foreach ($assocGrupOper as $grupos) {
    		$grupo[] = $grupos->getCdgrupoper();
    	}
    	 
    	return $grupo;
    }
    
 	public function getGrupOper() {
        $assocGrupOper = $this->verificaGrupoOper();
        if (is_array($assocGrupOper) === true) {
            $grupo = '';
            foreach ($assocGrupOper as $i => $grupos) {
                $grupo .= $grupos.'_';
            }
            
            /** @var $grupOper Grupoper[]*/
            $grupOper = Grupoper::getObjectsByWhere(
                'NRORG = ? AND INSTR(?, CDGRUPOPER) <> 0 AND IDPERMCARD IS NOT NULL',
                array(Ambiente::getNrorg(), $grupo)
                );

            if (count($grupOper)>0) {
                $permissoes = array();
                foreach ($grupOper as $permGrupos) {
                    $permissoes[] = $permGrupos->getIdpermcard();
                }
                
                $this->permissoes = $permissoes;
                return $this;
            }
        }
            
        /** Referente a quantidade de permissoes */ 
        $this->permissoes = array("111111111111111");

        return $this;
    }

    public function getOperPermiteIncluir() {
        $permInserir = '';
        foreach ($this->permissoes as $permissao) {
            $permInserir .= substr($permissao, 0, count($permissao));
        }
        
        return strpos($permInserir, '1') === false ? false : true;
    }

    public function getOperPermiteAlterar() {
        $permAlterar = '';
        foreach ($this->permissoes as $permissao) {
            $permAlterar .= substr($permissao, 1, count($permissao));
        }

        return strpos($permAlterar, '1') === false ? false : true;
    }

    public function getOperPermiteExcluirPrat() {
        $permExcluirPrat = '';
        foreach ($this->permissoes as $permissao) {
            $permExcluirPrat .= substr($permissao, 2, count($permissao));
        }
        
        return strpos($permExcluirPrat, '1') === false ? false : true;
    }

    public function getOperPermiteAltComDia() {
        $permAltComDia = '';
        foreach ($this->permissoes as $permissao) {
            $permAltComDia .= substr($permissao, 3, count($permissao));
        }
        
        return strpos($permAltComDia, '1') === false ? false : true;
    }

    public function getOperPermiteAltComMes() {
        $permAltComMes = '';
        foreach ($this->permissoes as $permissao) {
            $permAltComMes .= substr($permissao, 4, count($permissao));
        }
        
        return strpos($permAltComMes, '1') === false ? false : true;
    }

    public function getOperPermiteRevisarRece() {
        $permRevisarRece = '';
        foreach ($this->permissoes as $permissao) {
            $permRevisarRece .= substr($permissao, 5, count($permissao));
        }
        
        return strpos($permRevisarRece, '1') === false ? false : true;
    }

    public function getOperPermiteAnaliseCustoRevRec() {
        $permAnaliseCustoRevRec = '';
        foreach ($this->permissoes as $permissao) {
            $permAnaliseCustoRevRec .= substr($permissao, 6, count($permissao));
        }
        
        return strpos($permAnaliseCustoRevRec, '1') === false ? false : true;
    }

    public function getOperPermiteExcluirCard() {
        $permExcluirCard = '';
        foreach ($this->permissoes as $permissao) {
            $permExcluirCard .= substr($permissao, 7, count($permissao));
        }
        
        return strpos($permExcluirCard, '1') === false ? false : true;
    }

    public function getOperPermiteImpCard() {
        $permImpCard = '';
        foreach ($this->permissoes as $permissao) {
            $permImpCard .= substr($permissao, 8, count($permissao));
        }
        
        return strpos($permImpCard, '1') === false ? false : true;
    }

    public function getOperPermiteCopiar() {
        $permCopiar = '';
        foreach ($this->permissoes as $permissao) {
            $permCopiar .= substr($permissao, 9, count($permissao));
        }
        
        return strpos($permCopiar, '1') === false ? false : true;
    }

    public function getOperPermiteConfigCard() {
        $permConfigCard = '';
        foreach ($this->permissoes as $permissao) {
            $permConfigCard .= substr($permissao, 10, count($permissao));
        }
        
        return strpos($permConfigCard, '1') === false ? false : true;
    }

    public function getOperPermiteImpTpPrato() {
        $permImpTpPrato = '';
        foreach ($this->permissoes as $permissao) {
            $permImpTpPrato .= substr($permissao, 11, count($permissao));
        }
        
        return strpos($permImpTpPrato, '1') === false ? false : true;
    }

    public function getOperPermiteAtualDtRefe() {
        $permAtualDtRefe = '';
        foreach ($this->permissoes as $permissao) {
            $permAtualDtRefe .= substr($permissao, 12, count($permissao));
        }
        
        return strpos($permAtualDtRefe, '1') === false ? false : true;
    }

    public function getOperPermiteRanking() {
        $permRanking = '';
        foreach ($this->permissoes as $permissao) {
            $permRanking .= substr($permissao, 13, count($permissao));
        }
        
        return strpos($permRanking, '1') === false ? false : true;
    }

    public function getOperPermiteAtualDtRefeRecalc() {
        $permAtualDtRefeRecalc = '';
        foreach ($this->permissoes as $permissao) {
            $permAtualDtRefeRecalc .= substr($permissao, 14, count($permissao));
        }
        
        return strpos($permAtualDtRefeRecalc, '1') === false ? false : true;
    }
    
	public function getOperAutorizaAlterReqServico() {
        $grupoPermitido = $this->paramGeral->getCdgroperrese();
        if (empty($grupoPermitido)) {
         $grupos = $this->verificaGrupoOper();
         return in_array($grupoPermitido, $grupos) ? true : false;
        } else {
         return true; 
        }
    }

    // FIM PERMISSOES DE GRUPO DE OPERADORES
    
// FIM PARAMETROS DO PLANEJAMENTO
    
// PARAMENTROS GERAL
    
    public static function getPermiteComensalSemPrato() {
        return self::getInstancia()->paramGeral->getIdpercomensprat();
    }

    
// FIM PARAMENTROS GERAL

}