/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/* Nome: 0010_DENSTPO_USR_EXPORTAREDZ_DENADAI.sql                             */
/*                                                                            */
/* Descrio:                                                                 */
/* Procedure destinada a exportar informaes da ReduoZ geradas no sistema  */
/* da Teknisa para serem importadas no sistema da Microsiga e, para isso,     */
/* a procedure alimentar uma tabela intermediria entre os dois sistemas     */                                                */
/* (tabelas pertencentes ao banco de dados do sistema da Microsiga).          */
/*                                                                            */
/* Criao: 18/08/2008 - Leonardo Matos                                       */
/******************************************************************************/

CREATE OR REPLACE
PROCEDURE USR_EXPORTAREDZ_DENADAI IS
   V_FILIAL  VARCHAR(10);
   V_OUTROSR FLOAT;
   V_IMPDEBT FLOAT;
BEGIN
   FOR C_REDZEXPORT IN
      (SELECT CDFILIAL    , DTREDUCAOZ  , NRECFREDZ   , NRSERIEREDZ,
              NRREDREDZ   , VRGTREDZ    , NRPRIMCFREDZ, NRULTCFREDZ,
              VRTOTCANREDZ, VRVENBRUREDZ, VRTOTDESREDZ, VRSTRIBREDZ,
              VRISENCREDZ , VRNINCIDREDZ, VRISSREDZ   , NRREINIREDZ,
              CDCAIXA
         FROM REDUCAOZ
        WHERE NVL(USR_IDEXPORTA, 'S') = 'S'
          AND USR_DTEXPORTA IS NULL
        ORDER BY CDFILIAL, DTREDUCAOZ, NRECFREDZ
       )
   LOOP

   SELECT MAX(CDGRUPFILI)
     INTO V_FILIAL
     FROM FILGRUPFILI
    WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
      AND USR_IDPROTHEUS = 'S';

   SELECT SUM(VRACUTOTNFIS)
     INTO V_OUTROSR
     FROM TOTNFISCREDZ
    WHERE CDFILIAL   = C_REDZEXPORT.CDFILIAL
      AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
      AND NRECFREDZ  = C_REDZEXPORT.NRECFREDZ;

   SELECT SUM(VRIMPOSTORZ)
     INTO V_IMPDEBT
     FROM IMPOSTOREDZ
    WHERE CDFILIAL   = C_REDZEXPORT.CDFILIAL
      AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
      AND NRECFREDZ  = C_REDZEXPORT.NRECFREDZ;

    INSERT INTO USR_ZWD
       (WD_FILIAL , WD_DTMOVTO,
        WD_PDV    ,
        WD_SERPDV ,
        WD_NUMREDZ,
        WD_GTFINAL,
        WD_NUMINI , WD_NUMFIM ,
        WD_CANCEL , WD_VALCON ,
        WD_DESC   , WD_SUBTRIB,
        WD_ISENTO , WD_NTRIB  ,
        WD_ISS    , WD_CRO    ,
        WD_COO    , WD_OUTROSR,
        WD_NUMERO , WD_GTINI  ,
        WD_IMPDEBT, WD_DTGRV  ,
        WD_HRGRV  , WD_DTIMP  ,
        WD_HRIMP)
    VALUES
       (SUBSTR(V_FILIAL, 9, 2),
        TO_CHAR(C_REDZEXPORT.DTREDUCAOZ,'DDMMYYYY'),
        C_REDZEXPORT.CDCAIXA||TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRECFREDZ, 10, ' '),4,7)) ,
        TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRSERIEREDZ, 30, ' '),11,20)),
        TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRREDREDZ, 10, ' '),6,5)) ,
        C_REDZEXPORT.VRGTREDZ,
        TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRPRIMCFREDZ, 10, ' '),2,10)) ,
        TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRULTCFREDZ, 10, ' '),2,10)) ,
        C_REDZEXPORT.VRTOTCANREDZ, C_REDZEXPORT.VRVENBRUREDZ,
        C_REDZEXPORT.VRTOTDESREDZ, C_REDZEXPORT.VRSTRIBREDZ ,
        C_REDZEXPORT.VRISENCREDZ , C_REDZEXPORT.VRNINCIDREDZ,
        C_REDZEXPORT.VRISSREDZ   ,
        C_REDZEXPORT.NRREINIREDZ,   '000000',
        V_OUTROSR,
        TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRREDREDZ, 10, ' '),5,10)) ,
        (C_REDZEXPORT.VRGTREDZ - C_REDZEXPORT.VRVENBRUREDZ),
        V_IMPDEBT, TO_CHAR(TRUNC(SYSDATE), 'DDMMYYYY'),
        TO_CHAR(SYSDATE, 'HH24MI'), NULL,
        '');

   UPDATE REDUCAOZ
      SET USR_IDEXPORTA = 'N',
          USR_DTEXPORTA = SYSDATE
    WHERE CDFILIAL   = C_REDZEXPORT.CDFILIAL
      AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
      AND CDCAIXA    = C_REDZEXPORT.CDCAIXA
      AND NRECFREDZ  = C_REDZEXPORT.NRECFREDZ;
   END LOOP;
END;

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXPORTAREDZ_DENADAI','5.03.011'); END;
/

